import { Ref } from 'vue'
import { CellSlotProps } from '../../type'

export function useCount(flag: Ref<boolean>) {
  const tableColumnFormatter = (columnLabel: string) => {
    return unref(flag) ? columnLabel : columnLabel.replace('/件', '')
  }

  const tableDataFormatter = ({
    rowData,
    column: { columnName, columnLabel },
  }: CellSlotProps) => {
    const cellValue = rowData[columnName]
    if (!unref(flag)) {
      const matched = columnLabel.match(/(?<=\()\S+(?=\))/)
      if (matched) {
        const machedStr = matched[0]
        const countIndex = machedStr.split('/').findIndex(str => str === '件')
        if (
          countIndex > -1 &&
          typeof cellValue === 'string' &&
          cellValue.split('/')[countIndex]
        ) {
          return cellValue
            .split('/')
            .filter((_, index) => index !== countIndex)
            .join('/')
        }
      }
    }
    if (columnName.includes('Time') && typeof cellValue === 'string') {
      return cellValue.replace('T', '\n')
    }
    return cellValue
  }

  return {
    tableColumnFormatter,
    tableDataFormatter,
  }
}
